/*
 * coup.c
 */
#include "copyright.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"
#ifndef _NO_DEPEND
#   include "ntserv_protos.h"
#endif

#ifdef USE_SYS_PROTOS
#if defined(__STDC__) || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

#undef P_
#endif

/* throw a coup */

void
coup()
{
   register int    i;
   register struct planet *l;

   if (me->p_kills < 1.0) {
      warning(1, "You must have one kill to throw a coup", 3);
      return;
   }
   if (!(me->p_flags & PFORBIT)) {
      warning(1, "You must orbit your home planet to throw a coup", 4);
      return;
   }
   for (i = 0, l = &planets[i]; i < MAXPLANETS; i++, l++) {
      if ((l->pl_owner == me->p_team) && (l->pl_armies > 0)) {
	 warning(1, "You already own a planet!!!", 5);
	 return;
      }
   }
   l = &planets[me->p_planet];

   if ((!(l->pl_flags & PLHOME)) || ((l->pl_flags & ALLTEAM) != me->p_team)) {
      warning(1, "You must orbit your home planet to throw a coup", 6);
      return;
   }
   if (l->pl_armies > 4) {
      warning(1, "Too many armies on planet to throw a coup", 7);
      return;
   }
   if (l->pl_couptime > 0) {
      warning(1, "Planet not yet ready for a coup", 8);
      return;
   }
   if (l->pl_flags & PLCOUP) {	/* Avoid race conditions */
      return;
   }
   /* the cases are now met.  We can have a coup. */

   l->pl_flags |= PLCOUP;
}
