/*
 * util.c
 */
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

#ifdef USE_SYS_PROTOS
#if defined(__STDC__) || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

extern char *                 strncpy P_((char *, const char *, size_t));
extern int                    select P_((int width, fd_set * readfds, fd_set * writefds, fd_set * exceptfds, struct timeval * timeout));
extern void *                 malloc P_((size_t));

#undef P_
#endif

/*
 * * Provide the angular distance between two angles.
 */
int
angdist(x, y)
   unsigned char   x, y;
{
   register unsigned char res;

   res = ABS(x - y);
   if (res > 128)
      return (256 - (int) res);
   return ((int) res);
}

#if mips || defined(SYSV)
int
nint(x)
   double          x;
{
   double          rint();
   return (int) rint(x);
}
#endif

/* 
 * copy strings to 79 character destination without overwriting
 */

void
copy80(dest, addr_format, address, str)

   char	*dest;
   char	*addr_format;
   char	*address;
   char	*str;
{
   char		addr_buf[64];
   int		l;

   sprintf(addr_buf, addr_format, address);
   l = strlen(addr_buf);
   strncpy(dest, addr_buf, l);
   strncpy(&dest[l], str, 79-l);
   dest[79] = '\0';
}


void
my_sleep(secs)

   int  secs;
{
   struct timeval       timeout;
   timeout.tv_sec = secs;
   timeout.tv_usec = 0;
   select(32, 0, 0, 0, &timeout);
}

char           *
strdup(str)
#if defined(__STDC__)           /* doing this so strdup() will match
                                   prototype in string.h */
const
#endif
    char           *str;
{
   char           *s;

   s = (char *) malloc(strlen(str) + 1);
   strcpy(s, str);
   return (s);
}

/* ms time from start */
int
mstime()
{
   static
   struct timeval  tv_base;
   struct timeval  tv;

   if (!tv_base.tv_sec) {
      gettimeofday(&tv_base, NULL);
      return 0;
   }
   gettimeofday(&tv, NULL);
   return (tv.tv_sec - tv_base.tv_sec) * 1000 +
      (tv.tv_usec - tv_base.tv_usec) / 1000;
}

