#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#include <pwd.h>
#include "defs.h"
#include "struct.h"
char *malloc();

struct statentry 	player;
struct status 		sdummy;
struct status 		*status;
struct player		pdummy;
struct player 		*me;
struct stats 		*mystats;
int			hourratio = 1;

main(argc, argv)
int argc;
char **argv;
{
    FILE	*fi, *fo;
    struct player j;
    int	total_ticks = 0;
    int total_sbkills = 0;
    int total_sblosses = 0;
    int	i=0;
    int	cr;

    me = &pdummy;

    fi = fopen(GLOBAL, "r");
    if (fi < 0) {
	printf("Cannot open the global file!\n");
	exit(0);
    }
    fread((char *)&sdummy, sizeof(struct status), 1, fi);
    status = &sdummy;
    close(fi);
    fi = fopen(PLAYERFILE, "r");
    if (fi < 0) {
	perror(PLAYERFILE);
	exit(1);
    }
    fo = fopen(".TMP.players", "w");
    if (fo < 0) {
	perror(".TMP.players");
	exit(1);
    }

    while (fread((char *) &player, sizeof(struct statentry), 1, fi) == 1){
      
      total_ticks += player.stats.st_sbticks;
      total_sbkills += player.stats.st_sbkills;
      total_sblosses += player.stats.st_sblosses;

      player.stats.st_tticks = player.stats.st_sbticks;
      if(!player.stats.st_tticks)
	 player.stats.st_tticks = 1;
      player.stats.st_tlosses = player.stats.st_sblosses;
      player.stats.st_tkills = player.stats.st_sbkills;
      fwrite((char *)&player, sizeof(struct statentry), 1, fo);
      i++;
    }
    printf("read %d entries.\n", i);

    fclose(fi);
    fclose(fo);
    fo = fopen("NEW.global", "w");
    if (fo < 0) {
	perror("NEW.global");
	exit(0);
    }
    status->kills = total_sbkills;
    status->losses = total_sblosses;
    status->timeprod = total_ticks;
    fwrite((char *)status, sizeof(struct status), 1, fo);
    fclose(fo);

    /* now promote */

    fi = fopen(".TMP.players", "r");
    if (fi < 0) {
	perror(".TMP.players");
	exit(1);
    }
    fo = fopen("NEW.players", "w");
    if (fo < 0) {
	perror("NEW.players");
	exit(1);
    }

    while (fread((char *) &player, sizeof(struct statentry), 1, fi) == 1){

      mystats = &player.stats;
      pdummy.p_stats = player.stats;
      do {
	 cr = mystats->st_rank;
	 basepromo();
      } while(cr < mystats->st_rank);
      fwrite((char *)&player, sizeof(struct statentry), 1, fo);
   }
   fclose(fi);
   fclose(fo);

    exit(0);
}

#ifdef BASEPRACTICE
/* special promotion system for base practice */

static
struct rank sbranks[NUMRANKS] = {
    { 0.0, 0.0, 0.0, "Ensign"},
    { 2.0, 0.1, 0.0, "Lieutenant"},		/*    .2 */
    { 4.0, 0.3, 0.0, "Lt. Cmdr."}, 		/*   1.2 */
    { 8.0, 1.0, 0.0, "Commander"},		/*   8.0 */
    {15.0, 1.6, 0.0, "Captain"},		/*  24.0 */
    {20.0, 2.6, 0.0, "Flt. Capt."},		/*  52.0 */
    {25.0, 4.0, 0.0, "Commodore"},		/* 100.0 */
    {30.0, 5.3, 0.0, "Rear Adm."},		/* 159.0 */
    {40.0, 6.7, 0.0, "Admiral"}};		/* 268.0 */

basepromo()
{
   int		myrank = mystats->st_rank;
   double	mytime = (double)mystats->st_tticks/36000.;
   double	mydi;
   register	i, times;
   double	ratingTotals, dix;

   ratingTotals = offenseRating(me) * defenseRating(me);
   mydi = ratingTotals * mytime;

      /* enough time, enough ratings */
   if((mytime >= sbranks[myrank+1].hours/hourratio &&
      ratingTotals >= sbranks[myrank+1].ratings) ||

      /* not enough time, enough DI */
      mytime < sbranks[myrank+1].hours/hourratio &&
      ratingTotals*mytime >= sbranks[myrank+1].hours/hourratio *
	 sbranks[myrank+1].ratings){

      mystats->st_rank++;

      /* debug */
      printf("%s (%c%c) promoted to %s on normal DI.\n",
	 me->p_name, me->p_mapchars[0], me->p_mapchars[1],
	 sbranks[mystats->st_rank].name);
      printf("   def: %lf, off: %lf, (product: %lf) time: %lf\n",
	 defenseRating(me),
	 offenseRating(me),
	 ratingTotals,
	 mytime);
      fflush(stdout);

      return;
   }

   /* di X promotions */

   times = 2;
   i=0;

   while (myrank+i >= 0){

      dix = sbranks[myrank+1].hours/hourratio * sbranks[myrank+1].ratings * 
	 times;

      if(ratingTotals >= sbranks[myrank+i].ratings && 
	 ratingTotals * mytime >= dix ){

	 mystats->st_rank++;

	 /* debug */
	 printf("%s (%c%c) promoted to %s on %d X DI (%lf).\n",
	    me->p_name, me->p_mapchars[0], me->p_mapchars[1],
	    sbranks[mystats->st_rank].name,
	    times, dix);
	 printf("   def: %lf, off: %lf, (product: %lf) time: %lf\n",
	    defenseRating(me),
	    offenseRating(me),
	    ratingTotals,
	    mytime);
	 fflush(stdout);

	 return;
      }
      i --;
      times *= 2;
   }
}

#endif /* BASEPRACTICE */
