/*
 */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <signal.h>
#include <setjmp.h>
#include <sys/file.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <math.h>
#include <errno.h>
#include <pwd.h>
#include <ctype.h>
#include <time.h>
#include "defs.h"
#include "struct.h"


#if defined(__STDC__) || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

void openmem P_((void));

#ifdef USE_SYS_PROTOS
extern int                    shmget P_((key_t, int, int));
extern void                   perror P_((const char *));
extern int                    fprintf P_((FILE *, const char *, ...));
extern void *                 shmat P_((int, void *, int));
extern unsigned int           sleep P_((unsigned int));
extern int                    shmctl P_((int, int, ...));
extern time_t                 time P_((time_t *));
extern int                    printf P_((const char *, ...));
#endif

#undef P_

int             shmid;
int		t_only=0;	/* only during t-mode */
struct memory  *sharedMemory;
static int	old_phasers[MAXPLAYER];

void
openmem()
{
   extern int      errno;
   int             shmemKey = PKEY;

   errno = 0;
   shmid = shmget(shmemKey, 0, 0);
   if (shmid < 0) {
      if (errno != ENOENT) {
	 perror("shmget");
	 exit(1);
      }
      shmid = shmget(shmemKey, 0, 0);
      if (shmid < 0) {
	 fprintf(stderr, "dumpshmem: Daemon not running\n");
	 exit(1);
      }
   }
   sharedMemory = (struct memory *) shmat(shmid, 0, 0);
   if (sharedMemory == (struct memory *) - 1) {
      perror("shmat");
      exit(1);
   }
}

void
main(argc, argv)
   int             argc;
   char           *argv[];
{
   register	int i,*k, d, e;
   register struct phaser	*j;
   openmem();
   while(1) {

      for(i=0,j=sharedMemory->phasers, k=old_phasers; i< MAXPLAYER; 
		i++,j++,k++){
	 if(j->ph_status == PHHIT && *k != PHHIT){
	    d=(int)hypot((double)sharedMemory->players[i].p_x - 
			  sharedMemory->players[j->ph_target].p_x,
			  (double)sharedMemory->players[i].p_y - 
			  sharedMemory->players[j->ph_target].p_y);
	    e= (int)((double)sharedMemory->players[i].p_ship.s_phaserdamage*
	       (1.0 - ((double)d/(double)(PHASEDIST*sharedMemory->players[i].p_ship.s_phaserdamage/100))));
	    if(ABS(e - j->ph_damage) < 5)
	       continue;

	    printf("\n  %-20s%d\n", "phaser", i);
	    printf("    %-18s%d\n", "ph_dir:", (int)j->ph_dir);
	    printf("    %-18s%d\n", "ph_target:", (int)j->ph_target);
	    /*
	    printf("    %-18s%d\n", "ph_x:", (int)j->ph_x);
	    printf("    %-18s%d\n", "ph_y:", (int)j->ph_y);
	    */
	    printf("    %-18s%d\n", "distance:", 
	       d=(int)hypot((double)sharedMemory->players[i].p_x - 
			  sharedMemory->players[j->ph_target].p_x,
			  (double)sharedMemory->players[i].p_y - 
			  sharedMemory->players[j->ph_target].p_y));

	    printf("    %-18s%d\n", "ph_fuse:", (int)j->ph_fuse);
	    printf("    %-18s%d\n", "ph_damage:", (int)j->ph_damage);
	    printf("    %-18s%d\n", "ship", 
	       sharedMemory->players[i].p_ship.s_type);
	 }
	 *k = j->ph_status;
      }
      usleep(100000);
   }
   exit(0);
}
