#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#include <pwd.h>
#include "defs.h"
#include "struct.h"

#if defined(__STDC__) || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

char *nowhite P_((char *s));

#ifdef USE_SYS_PROTOS
extern int                    fprintf P_((FILE *, const char *, ...));
extern int                    atoi P_((const char *));
extern int                    close P_((int));
extern size_t                 fread P_((void *, size_t, size_t, FILE *));
extern void                   perror P_((const char *));
extern time_t                 time P_((time_t *));
extern char *                 ctime P_((const time_t *));
extern size_t                 fwrite P_((const void *, size_t, size_t, FILE *));
extern int                    fclose P_((FILE *));
extern int                    isspace P_((int));
extern void *                 malloc P_((size_t));
extern int                    printf P_((const char *, ...));
#endif

#undef P_

struct statentry player;
struct status   sdummy;
struct status  *status;
struct player   pdummy;
struct player  *me;
struct stats   *mystats;
int             hourratio = 1;

int             weeks_del = 4;
int             sec_del = 60;

void
main(argc, argv)
   int             argc;
   char          **argv;
{
   FILE           *fi, *fo;
   int             r = 0, d = 0;
   int		   seconds, tm;

   if (argc != 3) {
      fprintf(stderr, "usage: %s <weeks> <seconds>\n", argv[0]);
      fprintf(stderr, "\tplayers who haven't played in <weeks> and have\n");
      fprintf(stderr, "\tless then <seconds> tournament play-time are deleted.\n");
      exit(0);
   }
   weeks_del = atoi(argv[1]);
   sec_del = atoi(argv[2]);
   me = &pdummy;

   fi = fopen(GLOBAL, "r");
   if (!fi) {
      fprintf(stderr, "Cannot open the global file!\n");
      exit(0);
   }
   fread((char *) &sdummy, sizeof(struct status), 1, fi);
   status = &sdummy;
   fclose(fi);
#ifdef LARGE_DB
   fi = fopen(PLAYERFILE_DB, "r");
   if (!fi){
      perror(PLAYERFILE_DB);
      exit(1);
   }
#else
   fi = fopen(PLAYERFILE, "r");
   if (!fi){
      perror(PLAYERFILE);
      exit(1);
   }
#endif
   fo = fopen("NEW.players", "w");
   if (!fo) {
      perror("NEW.players");
      exit(1);
   }
   while (fread((char *) &player, sizeof(struct statentry), 1, fi) == 1) {

      seconds = player.stats.st_tticks/10;
      tm = time(NULL);

      if (seconds < sec_del && (tm - player.stats.st_lastlogin) >
	  (weeks_del * 7 * 24 * 60 * 60)){
	 d++;
	 r++;
	 printf("deleting %s %d, %f hours, last login: %s",
	    nowhite(player.name), player.stats.st_rank,
	    (float)seconds/3600., (char *)ctime(&player.stats.st_lastlogin));
	 continue;
      }

      fwrite((char *) &player, sizeof(struct statentry), 1, fo);
      r++;
   }
   fprintf(stderr, "read %d entries, deleted %d entries\n", r, d);
   fprintf(stderr, "Output in NEW.players.\n");

   fclose(fi);
   fclose(fo);
   exit(0);
}

char *
nowhite(s)

   char	*s;
{
   static char 	buf[32];
   char		*t = buf;

   while(*s){
      if(isspace(*s))
	 *t = '_';
      else
	 *t = *s;
      t++;
      s++;
   }
   *t = '\0';
   return buf;
}
